/*
 ********************************************************
	Rug Warrior Pro UMH-ISA (SITR)
 ********************************************************
	NOMBRE DEL ARCHIVO:   	pantalla.c
	FECHA:			
	AUTOR:   
	DESCRIPCIN:  Funciones de manejo de la pantalla
				  
	VARIABLES GLOBALES EXTERNAS:

    FUNCIONES EXTERNAS: 
		void wrap(char string[]);	
		int digits(int signed_val);
		void printn(int val, int cols);
		void print_byte(int val);
		void repeat_char(int ch, int rep);
		void therm(int val);
		void therm_diff (int val);
		int thermometer(int val, int low, int high);

	VARIABLES GLOBALES USO INTERNO:
		char _printstring[62];
		char _space[];

    FUNCIONES USO INTERNO: 

 ********************************************************
*/

/* January 10,1994  KPU  */
/* Prints text strings to screen with auto word wrap */
char _printstring[62]="                                    ";
char _space[]=" ";

void wrap(char string[])
{
  int i,j;

  if (_array_size(string)<17) printf("%s\n",string);
  else {

    for(i=16;i>0;i--){                   /* Find the nearest space before */
      if (string[i]==_space[0]) break;   /* the 17th character */
    }
    
    for(j=0;j<i;j++) _printstring[j]=string[j];   /* Transfer all characters */
    /* before the space into */
    /* the print string */
    
    for(j=i;j<16;j++) _printstring[j]=_space[0];  /* Pad the rest of the */
    /* first line with spaces */
    
    /* Put in the rest of the string to be printed  */
    for(j=0;j<_array_size(string)-i-1;j++) _printstring[j+16]=string[j+i+1];
    
    /* Put it on the LCD  */
    printf("%s\n",_printstring);
  }
}

/* Count the number of digits in an integer (negative numbers add 1 for - sign) */
int digits(int signed_val)
{ 
	int digs, val;
	val = abs(signed_val);
	if (val < 100)
    { 
		if (val < 10)
			digs = 1;
        else 
			digs = 2; 
	}
    else if (val < 10000)
    { 
		if (val < 1000)
			digs = 3;
        else 
			digs = 4; 
	}
    else 
		digs = 5;

	if (signed_val >= 0)
		return digs;
    else 
		return (digs + 1);
}


/* Print val in the given number of columns if possible */
void printn(int val, int cols)
{ 
	int digs;			/* Number of digits */
	digs = digits(val);
	if (digs >= cols)
		printf("%d", val);	/* May not be possible to print in required number of cols */
	else
	{ 
		repeat_char(32,cols - digs);
		printf("%d",val); 
	}
}

/* Print a 3 digit 8-bit integer that takes up exactly 3 characters */
void print_byte(int val)
{ 
	if (val < 10)
		printf("  %d", val); /* ..n */
	else if (val < 100)
		printf(" %d", val);  /* .nn */
	else
		printf("%d", val);   /* nnn */
}

/* Print character ch, rep times */
void repeat_char(int ch, int rep)
{ int j = 0;
  for (j = 0; j < rep; j++)
    printf("%c", ch);
}

/* Display an analog value on one line of the LCD */
/* Val 0 to 255 */
void therm(int val)	
{ 
  int j;
  int blks;			/* Number of blocks that are set: val/16 */
  blks = (val >> 4) + (1 & (val >> 3));	/* Divide with round off */
  for (j = 1; j<= blks; j++)
    printf(">");
  for (j = blks; j < 16; j++)
    printf("-");
}

/* 0123456789ABCDEF     */
/*        []       :  0 */ 
/*        [>>>>    :  4 */
/*   <<<<<<]       : -6 */
/* therm_diff is for displaying the difference between two quantities */
void therm_diff (int val)
{ 
  if (val == 0)
    printf("       []       ");	/* Zero */
  else if (val < -8)
    printf("%c<<<<<<<]       ",127);	/* Less than -8 */
  else if (val < 0)
    { repeat_char(32,8 + val);	/* 32 = space */
      repeat_char(60,abs(val));	/* 60 = "<" */
      printf("]       ");
    }
  else if (val > 8)
    printf("       [>>>>>>>%c",126);	/* More than +8 */
  else
    { printf("       [");
      repeat_char(62,val);
      repeat_char(32,8 - val);
    }
}

/* Display an analog value on one line of the LCD */
/* Uses integer division with more-or-less correct roundoff */
int thermometer(int val, int low, int high)
{ 
  int range = high - low;
  int blks = (((val - low) * 16) + (range >> 1)) / range;
  int j;
  if (blks < 0)
    blks = 0;
  else if (blks > 16)
    blks = 16;
  for (j = 1; j <= blks; j++)  printf("%c",219); /* 219 => [] */
  for (j = blks; j < 16; j++)  printf("-"); 
  return blks;
}
